Attribute VB_Name = "GTIni"
'-------------------------------------------------
' GameTools - INIt@C샂W[
'-------------------------------------------------

'ȉAAPI̕󂯎pTCY
Private Const CacheForValue = 1024
Private Const CacheForSection = 30000

'擾E
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'l擾
Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long

'ZNVif[^񋓁j擾E
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long

'ȉ̊֐APIr[A[ɂ͍ڂĂ܂
'ZNV
Private Declare Function GetPrivateProfileSectionNames Lib "kernel32" Alias "GetPrivateProfileSectionNamesA" (ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
'\́i[U[`^j擾E
Private Declare Function GetPrivateProfileStruct Lib "kernel32" Alias "GetPrivateProfileStructA" (ByVal lpszAppname As String, ByVal lpszKey As String, lpStruct As Any, ByVal uSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileStruct Lib "kernel32" Alias "WritePrivateProfileStructA" (ByVal lpszAppname As String, ByVal lpszKey As String, lpStruct As Any, ByVal uSize As Long, ByVal lpFileName As String) As Long

'INIf[^񋓗p
Type INISection
  SectionName As String
  NumKey As Long
  Key() As String
  Value() As String
End Type

'xp
Function ReplaceString(ByVal Target As String, ByVal FromString As String, ByVal ToString As String) As String
Dim a$, b$, c$, d$, i&, j&
'u(VB6ȍ~ȂReplace֐g)
a = Target
b = FromString
c = ToString
j = Len(FromString)

i = InStr(a, b)
Do While i <> 0
'u
a = Left(a, i - 1) + c + Right(a, Len(a) - i - j + 1)
i = InStr(a, b)
Loop

ReplaceString = a

End Function

'xp
Function SplitString(ByVal Target As String, ByVal Splitter As String) As Variant
'w肵ŕ
'Splitter͂PAKvȂReplaceString𗘗p
Dim st$()
Dim i&, j&, k&, s$, l&, l2&

i = 1
l = Len(Target)
l2 = Len(Splitter)
For j = 1 To l - l2 + 1
  If Mid(Target, j, l2) = Splitter Then
    s = Mid(Target, i, j - i)
    ReDim Preserve st(k) As String
    st(k) = s
    i = j + l2
    k = k + 1
  End If
Next

s = Mid(Target, i, j - i)
ReDim Preserve st(k) As String
st(k) = s

SplitString = st
End Function


Function GetIni(ByVal SectionName As String, ByVal Key As String, ByVal Default As String, ByVal FileName As String) As String 'iniǂݍ
'f[^擾

Dim s As String, i As Long

'ꎞobt@m
s = String(CacheForValue, " ")

'ǂݍ
Call GetPrivateProfileString(SectionName, Key, Default, s, Len(s), FileName)

'NULL폜
i = InStr(s, vbNullChar)
If i = 0 Then
  GetIni = ""
Else
  GetIni = Left(s, i - 1)
End If

End Function

Function GetIniInt(ByVal SectionName As String, ByVal Key As String, ByVal Default As Long, ByVal FileName As String) As Long
'lf[^擾
 
GetIniInt = GetPrivateProfileInt(SectionName, Key, Default, FileName)
End Function


Function WriteIni(ByVal SectionName As String, ByVal Key As String, ByVal WriteText As String, ByVal FileName As String) As Long 'ini
'f[^

WriteIni = WritePrivateProfileString(SectionName, Key, WriteText, FileName)
End Function


'ZNVꗗ擾
Function GetIniSection(ByVal SectionName As String, ByVal FileName As String) As INISection
Dim s$, t$, i&, j&, l&, k&, v As Variant
Dim ISec As INISection

s = String(CacheForSection, " ")

Call GetPrivateProfileSection(SectionName, s, Len(s), FileName)

'I[NULL+NULL폜
i = InStr(s, vbNullChar + vbNullChar)
If i = 0 Then
  t = ""
Else
  t = Left(s, i - 1)
End If

If t = "" Then
  With ISec
    .SectionName = SectionName
    .NumKey = 0
  End With
  GetIniSection = ISec
  Exit Function
End If

'NULL؂Ȃ̂Split
v = SplitString(t, vbNullChar)

With ISec
  .SectionName = SectionName
  j = UBound(v) - LBound(v)
  l = LBound(v)
  .NumKey = j + 1
  ReDim .Key(j) As String
  ReDim .Value(j) As String
  
  For i = 0 To j
    s = v(i + l)
    k = InStr(s, "=")
    If k = 0 Then
      .Key(i) = s
      .Value(i) = ""
    Else
      .Key(i) = Left(s, k - 1)
      .Value(i) = Right(s, Len(s) - k)
    End If
  Next
End With

GetIniSection = ISec

End Function



Function WriteIniSection(ISec As INISection, ByVal FileName As String) As Long
'ZNVꗗ
Dim i&, j&, s$

With ISec
  
  '`FbN
  If UBound(.Key) <> UBound(.Value) Or LBound(.Key) <> LBound(.Value) Then
    WriteIniSection = 1
    Exit Function
  End If
  
  '
  For i = LBound(.Key) To UBound(.Key)
    s = s + .Key(i) + "=" + .Value(i) + vbNullChar
  Next
  
  s = s + vbNullChar
  
  WriteIniSection = WritePrivateProfileSection(.SectionName, s, FileName)
  
End With

End Function


'ZNVꗗ擾
Function GetIniSectionList(ByRef IniSec() As INISection, ByVal FileName As String) As Long
Dim s$, t$, i&, j&, l&, k&, v As Variant
Dim ISec() As INISection

s = String(CacheForSection, " ")

Call GetPrivateProfileSectionNames(s, Len(s), FileName)

'I[NULL+NULL폜
i = InStr(s, vbNullChar + vbNullChar)
If i = 0 Then
  t = ""
Else
  t = Left(s, i - 1)
End If

If t = "" Then
  GetIniSectionList = 0
  Exit Function
End If

'NULL؂Ȃ̂Split
v = SplitString(t, vbNullChar)

j = UBound(v) - LBound(v)
l = LBound(v)
ReDim IniSec(j) As INISection

For i = 0 To j
  IniSec(i) = GetIniSection(v(i + l), FileName)
Next


GetIniSectionList = j + 1

End Function


Function GetValueFromSection(ISec As INISection, ByVal Key As String) As String
'IniSectionΉKeyAValue𓾂
Dim i&, j&

With ISec
For i = 0 To .NumKey - 1
  If .Key(i) = Key Then
    GetValueFromSection = .Value(i)
    Exit Function
  End If
Next
End With

GetValueFromSection = vbNullChar

End Function

Function GetSectionFromSectionList(ISec() As INISection, ByVal SectionName As String) As INISection
'IniSectionz񂩂ΉSectionAIniSection𓾂
Dim i&, j&
Dim TIS As INISection

For i = LBound(ISec) To UBound(ISec)
  If ISec(i).SectionName = SectionName Then
    GetSectionFromSectionList = ISec(i)
    Exit Function
  End If
Next

'Ȃꍇ
With TIS
  .SectionName = vbNullChar
  .NumKey = 0
End With

GetSectionFromSectionList = TIS

End Function


Function GetValueFromSectionList(ISec() As INISection, ByVal SectionName As String, ByVal Key As String) As String
Dim TIS As INISection

TIS = GetSectionFromSectionList(ISec(), SectionName)
If TIS.SectionName = vbNullChar Then
  GetValueFromSectionList = vbNullChar + vbNullChar
  Exit Function
ElseIf TIS.NumKey = 0 Then
  GetValueFromSectionList = vbNullChar
  Exit Function
End If

GetValueFromSectionList = GetValueFromSection(TIS, Key)

End Function
